Attribute VB_Name = "EanPruefziffer"
Option Explicit

Public Function fncEanPruefziffer(ByVal varEan As Variant)

' Drucksysteme Janz & Raschke GmbH
' http://www.jrdrucksysteme.de
' Code von: Jrn Janz
'
' Die Funktion gibt die EAN Prfziffer zurck
' "FALSCHER CODE" wird zurckgegeben wenn nicht 7, 12, 13 oder 17 Zeichen bergeben werden
' oder die bergabe Zeichen enthlt


' Fehlerbehandlung

    On Error GoTo ErrorHandler
    
' --- Variablen ---
   
    Dim strEAN As String
    Dim sngMultiplikator As Single
    Dim intZaehler As Integer
    Dim sngSumme As Single
    Dim bytPruefziffer
    
' --- Feld leer oder Zeichen enthalten?
    If IsNull(varEan) Or Not IsNumeric(varEan) Then
            fncEanPruefziffer = "FALSCHER CODE"
            Exit Function
    End If
    
' --- Eingabe berprfen / Korrekte Eingabe sicherstellen ---

     ' Prfziffer nur berechnen wenn die Anzahl der Stelle = 7 (EAN8) oder = 12 (EAN 13)
     ' oder = 13 (EAN 14 / GTIN) oder = 17 (NVE / SSCC)
     ' sonst den Wert FALSCHER CODE zurckgeben
    If Len(varEan) = 17 Or Len(varEan) = 13 Or Len(varEan) = 12 Or Len(varEan) = 7 Then
        strEAN = Format(varEan, "00000000000000000")
      Else
        'Wenn gewnscht Hinweis ausgeben
        'MsgBox "Bitte 7, 12, 13 oder 17 Stellen eingeben!"
        fncEanPruefziffer = "FALSCHER CODE"
        Exit Function
    End If

'
' --- Beispiel: Berechnung der Prfziffer des EAN 13
'
' Rechnebeispiel fr die Berechnung der EAN Prfziffer:
' a.  4   0   1   2   3   4   5   6   7   8   9   9     (Beispiel EAN (12 Stellen))
' b.  1   3   1   3   1   3   1   3   1   3   1   3     (Gewichtung 1 & 3)
' c.  4   0   1   6   3   12  5   18  7   24  9   27    (a x b = c)
' d.  Produktsumme (Zeile c):                     116
' e.  Aufrunden auf die nchste 10-ner Stelle
' f.  116 + 4 = 120
' g.  4 = Prfziffer
'
' ACHTUNG, bei der Gewichtung wird immer von RECHTS mit der 3 begonnen.

    ' Produktsumme bilden / Rechnen mit Gewichtung 3 & 1
    
    sngMultiplikator = 3

    For intZaehler = 17 To 1 Step -1
    
         sngSumme = sngSumme + Mid(strEAN, intZaehler, 1) * sngMultiplikator
         sngMultiplikator = 4 - sngMultiplikator ' Vielen Dank an Herrn Appelhagen fr die Idee!
               
    Next intZaehler
    
        
    ' Prfziffer aus der Produktsumme mit MOD (Restwert) ermitteln
    '
    ' Beispiel: 132 mod 10 gibt den Restwert 2 zurck
    '           10 - 2 = 8 Prfziffer
    '           140 mod 10 gibt den Restwert 0 zurck
    '           10 - 0 = 10 die richtige Prfziffer wre 0
    '           Die zweite Mod 10 Funktion ist ntig um die Prfziffer 0 zu erhalten
    '           (8 Mod 10 = Restwert 8 und 10 Mod 10 = Restwert 0)
        
        bytPruefziffer = (10 - (sngSumme Mod 10)) Mod 10
      
     ' Ausgabewert der Funktion
     fncEanPruefziffer = bytPruefziffer

ErrorHandler:   ' Fehlerbehandlungsroutine.
    
    Select Case Err.Number  ' Fehlernummer auswerten.

Case 13 ' Fehler "Falsche Eingabe"
                
            MsgBox "Bitte nur Zahlen eingeben!", vbExclamation
            
            
        Case Else
           ' Andere Flle hier bearbeiten...
    End Select
    
End Function
